﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Text.RegularExpressions;

using System.Data;
using System.Configuration;
using System.Data.SqlClient;

using cPage;

public partial class cPageList : System.Web.UI.Page
{
    public int p = 1;   //页码

    protected void Page_Load(object sender, EventArgs e)
    {
        #region 分页获得页码
        string _p = Request.QueryString["p"];

        if (string.IsNullOrEmpty(_p))
            _p = "1";

        if (IsIntType(_p))
        {
            p = Convert.ToInt32(_p);
        }
        else
        {
            ScriptManager.RegisterClientScriptBlock(this, typeof(Page), "cPageScript", "<script language=\"javascript\" type=\"text/javascript\">alert(\"页码不正确\");history.back();</script>", true);
            return;
        }
        #endregion


        if (!Page.IsPostBack)
        {
            cPageBind();
        }
    }

    protected void cPageBind()
    {
        string _url = Request.FilePath + "?p=[#p#]";
        int _pageNum = 8;           // 中间页码数量
        int _pageSize = 10;         // 每页记录数
        int _beginIndex = 0;        // 开始记录
        int _endIndex = 0;          // 结束记录


        string sqlc = "select count(ID) from info";
        string sqlorder = "order by ID desc";
        string sqltable = "info";


        DataTable DTc = GetDt(sqlc);

        lblpage.Text = mPage.getPage(Convert.ToInt32(DTc.Rows[0][0].ToString()), _pageSize, _pageNum, p, out _beginIndex, out _endIndex, _url);

        //sql server 分页代码（sql server 2005后版本可用）
        string sql = "";

        sql = "WITH NoPagedTable AS (" +
            "SELECT ROW_NUMBER() OVER (" + sqlorder + ") AS rowIndex, " +
            " * " +
            " FROM " + sqltable + " " +
            ")select * from NoPagedTable WHERE rowIndex>=" + _beginIndex + " and rowIndex<=" + _endIndex;
        //

        DataTable DT = GetDt(sql);

        cPage_repeaterList.DataSource = DT;
        cPage_repeaterList.DataBind();

    }

    protected void cPage_repeaterList_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemIndex > -1)
        {
            ((LinkButton)e.Item.FindControl("lnkbtnDel")).Attributes["onclick"] = "return confirm('确认要删除吗？');";
        }
    }

    protected void cPage_repeaterList_ItemCommand(object source, RepeaterCommandEventArgs e)
    {
        if (e.CommandName == "del")
        {
            try
            {
                long _ID = Convert.ToInt64(((HiddenField)(e.Item.FindControl("hfID"))).Value);

                string sql = "";

                sql = "delete info where ID=" + _ID;


                int flag = runSQL(sql);

                if (flag == 1)
                {
                    cPageBind();
                }
                else
                {
                    ScriptManager.RegisterClientScriptBlock(this, typeof(Page), "cPageScript", "<script language=\"javascript\" type=\"text/javascript\">alert(\"删除失败\");history.back();</script>", true);
            
                }

            }
            catch
            {
                ScriptManager.RegisterClientScriptBlock(this, typeof(Page), "cPageScript", "<script language=\"javascript\" type=\"text/javascript\">alert(\"数据格式不正确(异常)\");history.back();</script>", true);
            
            }
        }
    }

    /// <summary>
    /// 数据库操作，执行sql语句
    /// </summary>
    /// <param name="inSQL"></param>
    /// <returns></returns>
    public int runSQL(string inSQL)
    {
        SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
        SqlCommand sqlCmd = new SqlCommand(inSQL, conn);

        try
        {
            conn.Open();
            sqlCmd.CommandTimeout = 600;
            sqlCmd.ExecuteNonQuery();
            return 1;
        }
        catch
        {
            return 0;
        }
        finally
        {
            sqlCmd.Dispose();
            conn.Close();
            conn.Dispose();
        }
    }
    
    /// <summary>
    /// 数据库操作，根据sql获取DataTable
    /// </summary>
    /// <param name="inSQL"></param>
    /// <returns></returns>
    public DataTable GetDt(string inSQL)
    {
        SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
        SqlDataAdapter sqlDA = new SqlDataAdapter(inSQL, conn);
        DataTable outDt = new DataTable();

        conn.Open();
        sqlDA.SelectCommand.CommandTimeout = 600;
        sqlDA.Fill(outDt);

        sqlDA.Dispose();
        conn.Close();
        conn.Dispose();

        return outDt;

    }

    /// <summary>
    /// 判断是否是正整数
    /// </summary>
    /// <param name="text"></param>
    /// <returns></returns>
    public static bool IsIntType(string text)
    {
        Regex reg = new Regex("^[0-9]+$");
        Match ma = reg.Match(text);
        if (ma.Success)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

}